#if defined(__INTEL_COMPILER)
#include <ia32intrin.h>

extern int __intel_cpu_indicator;

#define CPU_FEATURE_MMX   0x00800000UL
#define CPU_FEATURE_FSXR  0x01000000UL
#define CPU_FEATURE_SSE   0x02000000UL
#define CPU_FEATURE_SSE2  0x04000000UL
#define CPU_FEATURE_SSE3  0x00000001UL
#define CPU_FEATURE_SSSE3 0x00000200UL
/*
    OLDSOS tags indicate that the CPU supports SSE[n],but operating system
    will throw an exception when they are used.
*/
#define CPU_TYPE_UNSPECAILZED                0x00000001UL
#define CPU_TYPE_FAMILY_5                    0x00000002UL
#define CPU_TYPE_FAMILY_6                    0x00000004UL
#define CPU_TYPE_FAMILY_5_MMX                0x00000008UL
#define CPU_TYPE_FAMILY_6_MMX                0x00000010UL
#define CPU_TYPE_FAMILY_6_MMX_FSXR           0x00000020UL
#define CPU_TYPE_FAMILY_6_MMX_FSXR_SSE_OLDOS 0x00000040UL
#define CPU_TYPE_FAMILY_6_MMX_FSXR_SSE       0x00000080UL
#define CPU_TYPE_FAMILY_F_SSE2_OLDOS         0x00000100UL
#define CPU_TYPE_FAMILY_F_SSE2               0x00000200UL
#define CPU_TYPE_FAMILY_6_MMX_FSXR_SSE2      0x00000400UL
#define CPU_TYPE_FAMILY_F_SSE3               0x00000800UL
#define CPU_TYPE_FAMILY_F_SSSE3              0x00001000UL

void __intel_cpu_indicator_init(void)
{
	int CPUInfo[4];
	__cpuid(CPUInfo, 1);
	/* SSSE3 Check */
	if(CPUInfo[2]&CPU_FEATURE_SSSE3)
	{
		__intel_cpu_indicator = CPU_TYPE_FAMILY_F_SSSE3;
		return;
	}
	/* SSE3 Check */
	if(CPUInfo[2]&CPU_FEATURE_SSE3)
	{
		__intel_cpu_indicator = CPU_TYPE_FAMILY_F_SSE3;
		return;
	}
	/* SSE2 Check */
	if(CPUInfo[3]&CPU_FEATURE_SSE2)
	{
		__intel_cpu_indicator = CPU_TYPE_FAMILY_F_SSE2;
		return;
	}
	/* SSE Check */
	if(CPUInfo[3]&CPU_FEATURE_SSE)
	{
		__intel_cpu_indicator = CPU_TYPE_FAMILY_6_MMX_FSXR_SSE;
		return;
	}
	__intel_cpu_indicator = CPU_TYPE_UNSPECAILZED;
}
#endif	/* for defined(__INTEL_COMPILER) */
